
#include <windows.h>  
#include <stdio.h>
#include "PutData.h"
#include "sqlext.h"  


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "SQLPutData()"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}


// buffer lengths
// ..............
#define NAME_LEN 20

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static HENV  hEnv  = NULL;
static HDBC  hDBC  = NULL;
static HWND  hList = NULL;
static PTR   pParamData;

static int   rgbDeptId;
static UCHAR rgbDeptName  [NAME_LEN+1];
static int   rgbDeptHeadId;

static UCHAR szSqlStr[] = 
   "Insert into department( dept_id, dept_name, dept_head_id ) "
   "Values ( ?, ?, ? )";
static UCHAR szLBStr[128];

// data being sent to the employee table.
// ......................................

static int   nDeptId    [2]             = { 600,          700          };
static UCHAR sDeptName  [2][NAME_LEN+1] = { "Accounting", "Accounting" };
static int   nDeptHeadId[2]             = { 501,          703          };

static SDWORD cbIdLen;
static SDWORD cbNameLen;
static SDWORD cbHeadIdLen;

   switch( uMsg )
   {
      case WM_CREATE :
              {
                 RETCODE retCode;

                 // Allocate Environment and Connection.
                 //.....................................
                 SQLAllocEnv( &hEnv );
                 SQLAllocConnect( hEnv, &hDBC );

                 // Connect to the data source
                 //...........................
                 retCode = SQLConnect( hDBC, 
                             "Test Data Source", SQL_NTS,
                             "DBA",              SQL_NTS,  
                             "SQL",              SQL_NTS );

                 if ( retCode != SQL_SUCCESS )
                 {
                    SQLFreeConnect( hDBC );
                    SQLFreeEnv( hEnv );
                    return( -1 );
                 }

                 if ( retCode == SQL_SUCCESS )
                 {
                    hList = CreateWindow( "LISTBOX", "",    
                                          LBS_NOTIFY | WS_VSCROLL | 
                                          WS_BORDER  | WS_CHILD | 
                                          WS_VISIBLE | LBS_NOINTEGRALHEIGHT, 
                                          0, 0, 
                                          0, 0,  
                                          hWnd,              
                                          (HMENU)101,              
                                          hInst,         
                                          NULL               
                                        );
                 }
              }
              break;

      case WM_SIZE :
              MoveWindow( hList, 0, 0, LOWORD( lParam ), 
                                       HIWORD( lParam ), TRUE );
              break; 
              
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        {
                           HSTMT   hStmt;
                           RETCODE retCodeExecute, retCodeParamData;
                           int     nRowIdx = 0;

                           // Set connection to Manual commit mode
                           // ..........................................
                           SQLSetConnectOption( hDBC, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF );

                           // Allocate a statement handle for the query.
                           // ..........................................
                           SQLAllocStmt( hDBC, &hStmt );

                           // Call SQLPrepare() to compile the query.
                           // .......................................
                           retCodeExecute = SQLPrepare( hStmt, szSqlStr, SQL_NTS );
                           
                           if( retCodeExecute != SQL_SUCCESS && 
                               retCodeExecute != SQL_SUCCESS_WITH_INFO )
                           {
                              SQLFreeStmt( hStmt, SQL_DROP );
                              break;
                           }
                           
                           // Call SQLBindParameter() to 
                           // bind buffers for the columns.
                           // .............................
                           retCodeExecute = SQLBindParameter( hStmt, 1, SQL_PARAM_INPUT, 
                                             SQL_C_DEFAULT, SQL_INTEGER,
                                             0, 0, 
                                             &rgbDeptId, 0, 
                                             &cbIdLen );
                           
                           retCodeExecute = SQLBindParameter( hStmt, 2, SQL_PARAM_INPUT, 
                                             SQL_C_CHAR, SQL_CHAR, 
                                             NAME_LEN, 0, 
                                             rgbDeptName, 0, 
                                             &cbNameLen );

                           retCodeExecute = SQLBindParameter( hStmt, 3, SQL_PARAM_INPUT, 
                                             SQL_C_DEFAULT, SQL_INTEGER, 
                                             0, 0, 
                                             &rgbDeptHeadId, 0, 
                                             &cbHeadIdLen );
                           
                           // Initialize the length values so we can 
                           // pass length data at execution time.
                           // ......................................
                           cbIdLen     = SQL_LEN_DATA_AT_EXEC(0);
                           cbNameLen   = SQL_LEN_DATA_AT_EXEC(0);
                           cbHeadIdLen = SQL_LEN_DATA_AT_EXEC(0);

                           // Call SQLExecute() to execute the query.
                           // .......................................
                           retCodeExecute = SQLExecute( hStmt );

                           while( nRowIdx < 2 && retCodeExecute == SQL_NEED_DATA )
                           {
                              // Get a pointer to the parameter data
                              // sent to SQLBindParameter().
                              // ...................................
                              retCodeParamData = SQLParamData( hStmt, &pParamData );

                              if( retCodeParamData == SQL_NEED_DATA )
                              {
                                 // Call SQLPutData() to fill parameter 
                                 // data for the columns.
                                 // ...................................
                                 if( pParamData == &rgbDeptId )
                                 {
                                    SQLPutData( hStmt, &nDeptId[nRowIdx], SQL_NTS );

                                    sprintf( szLBStr, "DeptId %d added", 
                                                      nDeptId[nRowIdx] );

                                    SendMessage( hList, LB_ADDSTRING, 0,
                                       (LPARAM)szLBStr );
                                 }
                                 else if ( pParamData == rgbDeptName )
                                 {
                                    SQLPutData( hStmt, sDeptName[nRowIdx], SQL_NTS );

                                    sprintf( szLBStr, "DeptName %s added", 
                                                      sDeptName[nRowIdx] );

                                    SendMessage( hList, LB_ADDSTRING, 0,
                                       (LPARAM)szLBStr );
                                 }
                                 else if( pParamData == &rgbDeptHeadId )
                                 {
                                    SQLPutData( hStmt, &nDeptHeadId[nRowIdx], SQL_NTS );

                                    sprintf( szLBStr, "DeptHead %d added", 
                                                      nDeptHeadId[nRowIdx] );

                                    SendMessage( hList, LB_ADDSTRING, 0,
                                       (LPARAM)szLBStr );
                                 }
                              }
                              else
                              {
                                 // Increment index into data.
                                 // ..........................
                                 nRowIdx++;

                                 if( nRowIdx < 2 )
                                 {
                                    retCodeExecute = SQLExecute( hStmt );
                                 }
                              }
                           }
                           
                           // Successful transactions occurred, the last value
                           // in retCodeExecute happens to be SQL_NEED_DATA.
                           // This is a result of the logic, note that the 
                           // 'SQL_NEED_DATA' request has been processed by now.
                           // ..................................................
                           if( nRowIdx == 2 && retCodeExecute == SQL_NEED_DATA )
                           {
                              // Commit the transaction.
                              // .......................
                              SQLTransact( SQL_NULL_HENV, hDBC, SQL_COMMIT );

                              SendMessage( hList, LB_ADDSTRING, 
                                           0, (LPARAM)"Inserts successful." );
                           }
                           else
                           {
                              // Rollback the transaction.
                              // .........................
                              SQLTransact( SQL_NULL_HENV, hDBC, SQL_ROLLBACK);

                              SendMessage( hList, LB_ADDSTRING, 
                                           0, (LPARAM)"Inserts failed." );
                           }
                           
                           // Free the statement handle.
                           // ..........................
                           SQLFreeStmt( hStmt, SQL_DROP );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);

              // Disconnect Environment.
              //........................
              SQLDisconnect( hDBC );

              // Free Connection and Environment.
              //.................................
              SQLFreeConnect( hDBC );
              SQLFreeEnv( hEnv );
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}

LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
